#!/usr/local/bin/python
############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################
import getopt, sys
from threading import *
from pyGlobus.gramClient import GramClient, GramClientException
from pyGlobus import gramClient
cond = 0

def func(cv, contact, state, error):
    global cond
    if state == 1:
        print "Job is pending"
    elif state == 2:
        print "Job is active"
    elif state == 4:
        print "Job failed"
        cv.acquire()
        cond = 1
        cv.notify()
        cv.release()
    elif state == 8:
        print "Job is done"
        cv.acquire()
        cond = 1
        cv.notify()
        cv.release()

def test(rm, rsl):
    global cond
    condV = Condition(Lock())
    try:
        gC = GramClient()
        callbackContact = gC.set_callback(func, condV)
        jobContact = gC.submit_request(rm, rsl, gramClient.JOB_STATE_ALL,
                                               callbackContact)
    except GramClientException, ex:
        print ex.args
        sys.exit(-1)
    print "sumbitted the job, waiting for callbacks"
    while cond == 0:
        condV.acquire()
        condV.wait()
        print "made it out of the wait"
        condV.release()
    try:
        print "trying to remove the callback"
        gC.remove_callback(callbackContact)
        print "removed callback"
    except GramClientException, ex:
        print ex.args
        sys.exit(-1)

def usage():
    useStr = """Usage: testGramClient [-h] -c <resource manager contact> -r <rsl>"""
    print useStr
    
def getArgs():
    if len(sys.argv) == 1:
        usage()
        sys.exit(-1)
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hc:r:")
    except getopt.GetoptError:
        usage()
        sys.exit(-1)
    for o, a in opts:
        if o == "-h":
            usage()
            sys.exit(-1)
        elif o == "-c":
            contact = a
        elif o == "-r":
            rsl = a
    return contact, rsl

rm, rsl = getArgs()


test(rm, rsl)
