import ConfigParser, unittest
from pyGlobus.replicaCatalog import Collection
from pyGlobus.replicaCatalog import create
from pyGlobus import replicaCatalogc
from pyGlobus.util import GlobusException

"""
Unittest for the Collection module.
"""

config = None # ConfigParser object

class CollectionTestCase(unittest.TestCase):
    """
    Test case for the Collection class.
    """

    def checkOpen(self):
        global config
        print "\nCollectionOpenTestCase begin\n"
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read("config.py")
        try:
            url = "ldap://ldap2.mcs.anl.gov/lc=Test Collection,rc=KJCatalog,ou=ANL,o=Globus,o=Grid"
            mode = replicaCatalogc.GLOBUS_REPLICA_CATALOG_AUTHENTICATION_MODE_CLEARTEXT
            bindDN = "cn=Directory Manager"
            passwd = "beholder"
            col = Collection(url, mode, None, bindDN, passwd)
            del col
            print "\nCollectionOpenTestCase completed\n"
        except GlobusException, ex:
            print "Exception occured during testing."
            assert 0, ex.args
        return

    def checkCreateDelete(self):
        global config
        print "\nCollectionCreateDeleteTestCase begin\n"
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read("config.py")
        try:
            url = "ldap://ldap2.mcs.anl.gov/lc=Test Collection Tmp,rc=KJCatalog,ou=ANL,o=Globus,o=Grid"
            mode = replicaCatalogc.GLOBUS_REPLICA_CATALOG_AUTHENTICATION_MODE_CLEARTEXT
            bindDN = "cn=Directory Manager"
            passwd = "beholder"
            col = create(url, mode, None,
                                    replicaCatalogc.LOCATION_OBJECTCLASS,
                                    None, bindDN, passwd)
            col.delete()
            print "\nCollectionCreateDeleteTestCase completed\n"
        except GlobusException, ex:
            print "Exception occured during testing."
            assert 0, ex.args
        return
    
def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(CollectionTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    
                  

