from pyGlobus.ftpClient import FtpClient
from pyGlobus.ftpClient import EasyFtpClient
from pyGlobus.ftpClient import HandleAttr
from pyGlobus.ftpClient import OperationAttr
from pyGlobus.ftpClient import DebugPlugin
from pyGlobus.ftpClient import RestartMarkerPlugin
from pyGlobus.ftpClient import RestartMarker
from pyGlobus import ftpControl
from pyGlobus import ftpClientc
from pyGlobus.util import Buffer
from pyGlobus.util import Abstime
import unittest,ConfigParser, sys, traceback
from pyGlobus.util import GlobusException
from threading import *
from exceptions import Exception
import time


hack_cond = Condition(Lock())

g_X = None
g_cond = 0
g_file = None
g_oldCbHandle = None
g_newCbHandle = None
g_ftpClient = None
marker_str = None
#The config file is ~/pyGlobus/test/config.py
config_file = 'config.py'
config = None # ConfigParser object


def beginCB(arg, handle, srcUrl, destUrl, marker):
    ret = 0
    global marker_str
    print "inside the beginCB"
    if marker_str:
        print "\tRestart Marker String: ", marker_str
        ftpClientc.restart_marker_from_string(marker, marker_str)
        print "\tout"
        ret = 1
    print "leaving beginCB"
    return ret

def markerCB(arg, handle, marker):
    global marker_str
    print "inside the markerCB"
    ret, err, marker_str = ftpClientc.restart_marker_to_string(marker)
    print "restart marker string is: %s" % marker_str
    return

def marker_abort_CB(arg, handle, marker):
    print "inside the marker_abort_CB"
    global marker_str, g_ftpClient
    ret, err, marker_str = ftpClientc.restart_marker_to_string(marker)
    
    try:
        g_ftpClient.abort()
    except Exception:
        print "Failed Abort"
    else:
        print "\tabort"
        '''
        global g_cond, g_condV
        g_condV.acquire()
        g_cond = 1
        g_condV.notify()
        g_condV.release()
        '''
    print "\trestart marker string is: %s" % marker_str
    return

def completeCB(arg, handle, err, url):
    print "inside the complete CB"
    if not err == "NONE":
        print "got the following error: %s" % err
    """
    if marker_str:
        global g_cond, g_condV
        g_condV.acquire()
        g_cond = 1
        g_condV.notify()
        g_condV.release()
    """
    return

class FtpClientTestCaseOne(unittest.TestCase):
    "Test case for the FtpClient Module"

    def setUp(self):
        
        global config
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read(config_file)
        return
    
    def tearDown(self):
        global g_ftpClient
        print "in tearDown"
        time.sleep(2)
        try:
            del g_ftpClient
        except GlobusException, ex:
            print ex.args

        print "leaving tearDown"
        g_ftpClient = None
        return

    
    
    def checkFtpClientPut(self):
        print "Unittest for the FtpClientPut case"
        global g_file,g_ftpClient, g_newCbHandle, g_cond,g_buffer 
        
        src = config.get("ftpClient", "src")
        url = config.get("ftpClient", "url")
        print "Src file", src
        print "url: ", url
        g_file = open(src, "r")
        f = open("/tmp/test-file", "w+")
        condV = Condition(Lock())
        try:
            debug_plugin = DebugPlugin(f, "foobar")
            plugin = RestartMarkerPlugin(beginCB, markerCB,
                                         completeCB, None)
            handleAttr = HandleAttr()
            g_ftpClient = FtpClient(handleAttr)
            g_X = g_ftpClient
            opAttr = OperationAttr()
            opAttr.set_mode(ftpControl.MODE_EXTENDED_BLOCK)
            g_cond = 0
            size = 64*1024
            oset = 0
            g_buffer = g_file.read(size)
            condV.acquire()
            g_cond = 0
            g_ftpClient.put(url,done_func, condV,opAttr)
            cb = g_ftpClient.register_write(g_buffer, len(g_buffer), oset, g_buffer == "",
                                        data_func_put, 0)
            g_newCbHandle = cb
        except GlobusException, ex:
            print ex.args
            sys.exit(-1)

        print "waiting on done_func"
        while g_cond == 0:
            condV.wait()
        print "done waiting"
        condV.release()
    
            
        g_file.close()
        f.close()
        print "DONE"
        return
        
    def checkFtpClientGet(self):
        print " Unittest for the ftpClientGetTestCase"
        global g_dest, g_ftpClient, g_buffer, g_newCbHandle
        
        dest = config.get("ftpClient", "dest")
        url = config.get("ftpClient", "srcUrl")
        url = 'gsiftp://diesel.lbl.gov/home/g5/users/mateo/pyGlobus/examples/dump'
        print "Destination File: ", dest
        print "Retrieving URL: ", url
        g_dest = open(dest, "w")
        condV = Condition(Lock())
        
        try:
            handleAttr = HandleAttr()
            plugin = RestartMarkerPlugin(beginCB, markerCB,
                                         completeCB, None)
            handleAttr.add_plugin(plugin)
            g_ftpClient = FtpClient(handleAttr)
            opAttr = OperationAttr()
            opAttr.set_mode(ftpControl.MODE_EXTENDED_BLOCK)
            condV.acquire()
            g_ftpClient.get(url, done_func, condV,opAttr)
            g_buffer = Buffer(64*1024)
            handle = g_ftpClient.register_read(g_buffer, data_func_get, 0)
            g_newCbHandle = handle
        except GlobusException, ex:
            print ex.args
            sys.exit(-1)
        
        print "waiting on callbacks"
        condV.wait()
        condV.release()
        g_dest.close()
        try:
            del g_buffer
        except GlobusException, ex:
            print ex.args

    
        
class FtpClientTestCaseTwo(unittest.TestCase):
    "Test case for the FtpClient Module"

    def setUp(self):
        global config
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read(config_file)
        return
    
    def tearDown(self):
        global g_ftpClient
        print "in tearDown"
        time.sleep(2)
        try:
            del g_ftpClient
        except GlobusException, ex:
            print ex.args
        g_ftpClient = None
        print "leaving tearDown"
        return

    
    def checkFtpClientDelete(self):
        print "Unittest for the ftpClientDelete Test Case"
        global g_dest, g_ftpClient, g_buffer, g_newCbHandle, g_cond
        url = config.get("ftpClient", "url")
        condV = Condition(Lock())
        print url
        try:
           handleAttr = HandleAttr() 
           debug_plugin = DebugPlugin(sys.stdout, "Delete")
           #handleAttr.add_plugin(debug_plugin)
           g_ftpClient = FtpClient(handleAttr)
           opAttr = OperationAttr()
           condV.acquire()
           g_cond = 0
           print "calling delete in test_ftp"
           g_ftpClient.delete(url,opAttr, done_func, condV)
           print "return from delete call"
           
        except GlobusException, ex:
            print "globus exception"
            print ex.args

        print "waiting on callback"
        condV.wait()
        condV.release()

    def checkFtpClientSize(self):
        print "Unittest for size"
        global g_file, g_ftpClient, g_newCbHandle, g_cond
        f = open("/tmp/test-file", "w+")
        url = config.get("ftpClient", "srcUrl")
        condV = Condition(Lock())
        try:
            debug_plugin = DebugPlugin(f, "foobar")
            plugin = RestartMarkerPlugin(beginCB, markerCB,
                                         completeCB, None)
            handleAttr = HandleAttr()
            #handleAttr.add_plugin(plugin)
            #handleAttr.add_plugin(debug_plugin)
            g_ftpClient = FtpClient(handleAttr)
            opAttr = OperationAttr()
            opAttr.set_mode(ftpControl.MODE_EXTENDED_BLOCK)
            condV.acquire()
            g_cond = 0
            size =  g_ftpClient.size(url,done_func, condV, opAttr)
              
        except GlobusException, ex:
            raise
            #sys.exit(-1)

        print "waiting for callbacks"
        condV.wait()
        condV.release()
        
        print "size is: ", size.getLong()
        del size
        print "DONE"

    def checkFtpClientMtime(self):
    
        print "Unittest for modification time"
        global g_file, g_ftpClient, g_newCbHandle, g_cond 
        f = open("/tmp/test-file", "w+")
        url = config.get("ftpClient", "srcUrl")
        condV = Condition(Lock())
        try:
            debug_plugin = DebugPlugin(f, "foobar")
            plugin = RestartMarkerPlugin(beginCB, markerCB,
                                         completeCB, None)
            handleAttr = HandleAttr()
            handleAttr.add_plugin(plugin)
            handleAttr.add_plugin(debug_plugin)
            g_ftpClient = FtpClient(handleAttr)
            opAttr = OperationAttr()
            opAttr.set_mode(ftpControl.MODE_EXTENDED_BLOCK)
            g_cond = 0
            condV.acquire()
            mt =  g_ftpClient.modification_time(url, done_func, condV, opAttr)
            
            print "waiting for callback"
            while g_cond == 0:
                condV.wait()
            
            condV.release()
        except GlobusException, ex:
            raise
        time.sleep(2)
        print "Modification_time is: ", time.ctime(mt.getSecs())
        print "DONE"    


    def checkFtpClientExists(self):
        print "Unittest for exists"
        global  g_file, g_ftpClient, g_newCbHandle, g_cond
        f = open("/tmp/test-file", "w+")
        bad_url = config.get("ftpClient", "badUrl")
        print "Bad url: ", bad_url
        condV = Condition(Lock())
        try:
            debug_plugin = DebugPlugin(f, "foobar")
            plugin = RestartMarkerPlugin(beginCB, markerCB,
                                         completeCB, None)
            handleAttr = HandleAttr()
            #handleAttr.add_plugin(plugin)
            #handleAttr.add_plugin(debug_plugin)
            g_ftpClient = FtpClient(handleAttr)
            opAttr = OperationAttr()
            opAttr.set_mode(ftpControl.MODE_EXTENDED_BLOCK)
            condV.acquire()
            g_cond = 0
            g_ftpClient.exists(bad_url, done_func_error_expected, condV, opAttr)
            

            while g_cond == 0:
                condV.wait()
                condV.release()
        except GlobusException, ex:
            raise
        print "DONE"
        
    def checkFtpClientAbort(self):
        """This has a time.sleep, to give the ftp handle a chance to connect, before the
              operation is aborted.
              Otherwise this error is printed out 
              globus_ftp_control_force_close: Handle is not connected
              If this happens the complete callback is never called which means the function will hang
              because the condition variables are not notified.
              """
        global g_cond, g_ftpClient
        print "Unittest for ftpClient abort test"
        src = config.get("ftpClient", "src")
        url = config.get("ftpClient", "url") 
        
        condV = Condition(Lock())
        try:
            handleAttr = HandleAttr()
            #plugin = RestartMarkerPlugin(beginCB, marker,  completeCB, None)
            #handleAttr.add_plugin(plugin)
            g_ftpClient = FtpClient(handleAttr)
            condV.acquire()
            g_cond = 0
            g_ftpClient.put(url, done_func_error_expected, condV)
            time.sleep(1)
            g_ftpClient.abort()
            
        except GlobusException, ex:
            print ex
            
        print "waiting on callbacks"
        while g_cond == 0:
            condV.wait()
            condV.release()
        
             
    
        
class FtpClientTestCaseThree(unittest.TestCase):
    "Test case for the FtpClient Module"

    def setUp(self):
        global config
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read(config_file)
        return
    
    
    def tearDown(self):
        global g_ftpClient
        print "in tearDown"
        time.sleep(2)
        try:
            del g_ftpClient
        except GlobusException, ex:
            print ex.args

        print "leaving tearDown"
        return
    
    def checkThirdPartyTransfer(self):
        print " Unittest for the ftpClient3rdpartyTestCase"
        global g_cond, g_dest, g_ftpClient, g_buffer, g_newCbHandle   
        g_cond = 0

        srcUrl = config.get("ftpClient", "srcUrl")
        destUrl = config.get("ftpClient", "destUrl")
        print "From: ", srcUrl, " To: ", destUrl
        condV = Condition(Lock())
        try:
            handleAttr = HandleAttr()
            plugin = RestartMarkerPlugin(beginCB, markerCB,
                                          completeCB, None)
            handleAttr.add_plugin(plugin)
            g_ftpClient = FtpClient(handleAttr)
            
            opAttr = OperationAttr()
            condV.acquire()
            cb = g_ftpClient.third_party_transfer(srcUrl,destUrl,
                                                  done_func, condV)
            
        except GlobusException, ex:
            print "globus exception"
            print ex.args

        while g_cond == 0:
            print "waiting on callback"
            condV.wait()
            condV.release()
        
        print "DONE"
        
    def checkPartialThirdPartyTransfer(self, offset=0L, endOffset=10L):
        print " Unittest for the ftpClient3rdpartyPartialTestCase"
        global g_cond, g_ftpClient 

        srcUrl = config.get("ftpClient", "srcUrl")
        destUrl = config.get("ftpClient", "destUrl")
        destUrl = destUrl + '_partial1'
        
        srcAttr = OperationAttr()
        srcAttr.set_mode(ftpControl.MODE_EXTENDED_BLOCK)
        dstAttr = OperationAttr()
        dstAttr.set_mode(ftpControl.MODE_EXTENDED_BLOCK)
        
        condV   = Condition(Lock())
        marker  = RestartMarker()
        r_plugin = RestartMarkerPlugin(beginCB, markerCB,
                                     completeCB, None)
        for i in range(3):
            g_cond = 0
            try:
                handleAttr = HandleAttr()
                handleAttr.add_plugin(r_plugin)
                g_ftpClient = FtpClient(handleAttr)
                condV.acquire()
                print "Into ptpt\n\tsrc(%s) dst(%s)" % (srcUrl, destUrl)
                cb = g_ftpClient.partial_third_party_transfer(srcUrl, srcAttr, destUrl, \
                                                              dstAttr, marker, offset, \
                                                              endOffset, done_funcPT, condV)
                
            except GlobusException, ex:
                print "globus exception"
                print ex.args
                break
            else:
                while g_cond == 0:
                    print "waiting on callback"
                    condV.wait()
                    condV.release()
                # seem to have cleanup problem w/ 2GHz P4
                time.sleep(0.001)
                offset = endOffset
                endOffset = offset + 1
            
        print "DONE"

    def checkRestartMarkerPlugin(self, offset=0L, endOffset=100L):
        print " Unittest for the checkRestartMarkerPlugin"
        global g_condV, g_dest, g_ftpClient, g_buffer, g_newCbHandle   
        destUrl = config.get("ftpClient", "destUrl")
        srcUrl = config.get("ftpClient", "srcUrl")
        print "srcUrl = %s" % srcUrl
        print "dstUrl = %s" % destUrl
        
        condV = Condition(Lock())
        _markerCB_func = marker_abort_CB
        for i in range(2):
            print "-Start trans ->"
            try:
                handleAttr = HandleAttr()
                plugin = RestartMarkerPlugin(beginCB, _markerCB_func,
                                             completeCB, None)
                handleAttr.add_plugin(plugin)
                g_ftpClient = FtpClient(handleAttr)
                opAttr = OperationAttr()
                #opAttr.set_mode(ftpControl.MODE_EXTENDED_BLOCK)
                #print "mode is: %s" % opAttr.get_mode()
                condV.acquire()
                cb = g_ftpClient.third_party_transfer(srcUrl,destUrl,
                                                      done_func, condV)
            except GlobusException, ex:
                print "globus exception"
                print ex
            else:
                print "waiting for callbacks"
                condV.wait()
                condV.release()
            time.sleep(0.001)
            _markerCB_func = markerCB            
        print "DONE"
        return


        
def done_func_error_expected(cv, handle, error):
    global g_cond
    if not error == "NONE":
        print error
        print "TEST PASSED"
    else:
        print "TEST FAILED"
    cv.acquire()
    g_cond = 1
    cv.notify()
    cv.release()    
    return

def done_func(cv, handle, error):
    global g_cond
    
    print "inside done func"
    if not error == "NONE":
        print "The following error occured: %s" % error
    cv.acquire()
    g_cond = 1
    cv.notify()
    cv.release()
    return

def done_func_sem(sem, handle, error):
    print "in done_Func sem"
    sem.release()
    return

def done_funcPT(cv, handle, error):
    global g_cond
    print "done_funcPT"
    cv.acquire()
    if not error == "NONE":
        cv.notify()
        cv.release()
        print "The following error occured: %s" % error
        raise GlobusException, error
    else:
        g_cond = 1
    cv.notify()
    cv.release()
    return

def data_func_put(cv, handle, buffer, bufHandle, bufLen, offset, eof, error):
    global g_file, g_ftpClient, g_oldCbHandle, g_newCbHandle, g_buffer
    print "in data_func_put callback"
    
    if not eof:
        
        try:
            size = 1024 *64
            g_buffer = g_file.read(size)
            
            cb = g_ftpClient.register_write(g_buffer, len(g_buffer), bufLen + offset,
                                            g_buffer == "", data_func_put, 0)
            if not g_oldCbHandle == None:
                g_ftpClient.free_callback(g_oldCbHandle)
            g_oldCbHandle = g_newCbHandle
            g_newCbHandle = cb
        except Exception, e:
            traceback.print_exception()
            sys.exit(-1)
    return

def data_func_get(cv, handle, buffer, bufHandle, bufLen, offset, eof, error):
    global g_dest, g_ftpClient, g_buffer, g_oldCbHandle, g_newCbHandle
    g_dest.write(buffer)
    if not eof:
        try:
            handle = g_ftpClient.register_read(g_buffer, data_func_get, 0)
            if not g_oldCbHandle == None:
                g_ftpClient.free_callback(g_oldCbHandle)
            g_oldCbHandle = g_newCbHandle
            g_newCbHandle = handle
        except Exception, e:
            traceback.print_exception()
            sys.exit(-1)
    return




def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(FtpClientTestCaseOne, "check"))
    suite.addTest(unittest.makeSuite(FtpClientTestCaseTwo, "check"))
    suite.addTest(unittest.makeSuite(FtpClientTestCaseThree, "check"))
    return suite

def makePartialTest():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(FtpClientTestCase, "checkRestartMarkerPlugin"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
   
 
