from pyGlobus import utilc
from pyGlobus.util import GlobusException
from pyGlobus.ftpControl import FtpControl
from pyGlobus.ftpControl import Parallelism
from pyGlobus.ftpControl import HostPortArray
from pyGlobus.ftpControl import TcpBuffer
from pyGlobus.ftpControl import DCAU
from pyGlobus.security import GSSCred
import unittest,ConfigParser
from pyGlobus import ftpControlc
from pyGlobus import ftpControl

config = None
config_file = 'config.py'

class FtpControlTestCaseOne(unittest.TestCase):

    def setUp(self):
        global config
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read(config_file)
        self._ftpServer = FtpControl()

    def tearDown(self):
        print "DONE"
        
    def check_local_send_eof(self):
        print "in check_local_send_eof"
        eof = 1
        self._ftpServer.local_send_eof(eof)
        
    """    
    def check_quit(self):
        print "in check_quit"
        self._ftpServer.quit(self.quit_callback,0)
       """    
    def response_callback(arg,handle, error, response):
        print "in response callback"

    def check_local_parallelism(self):
        print "in check_local_parallelism"
        parallel = Parallelism()
        self._ftpServer.local_parallelism(parallel)

    def chek_local_spas(self):
        """No real point in testing this function since globus hasn't implemented it yet"""
        print "in check_local_spas"
        size = 10
        hp_array = HostPortArray(size)
        self._ftpServer.local_spas(hp_array)

    def chek_local_spor(self):
        print "in check_local_spor"
        size = 10
        hp_array = HostPortArray(size)
        self._ftpServer.local_spor(hp_array)

    def chek_local_mode(self):
        print "in check_local_mode"
        mode = ftpControl.MODE_EXTENDED_BLOCK
        #only STREAM and EXTENDED_MODE are supported for this call in the current
        #implementation
        mode = 'S'
        self._ftpServer.local_mode(mode)

    def check_local_tcp_buffer(self):
        print "in check_local_tcp_buffer"
        tcpBuf = TcpBuffer()
        size = 100
        tcpBuf.set_fixed(size)
        self._ftpServer.local_tcp_buffer(tcpBuf)
        

    def chek_local_dcau(self):
        print "in check_local_dcau"
        dcau = DCAU()
        mode = ftpControl.DCAU_SELF
        dcau.set_mode(mode)
        cred = GSSCred()
        self._ftpServer.local_dcau(dcau, cred)
        
    def check_local_pbsz(self):
        print "in check_local_pbsz"
        size = 100
        self._ftpServer.local_pbsz(size)
        
class FtpControlTestCaseTwo(unittest.TestCase):

    def setUp(self):
        global config
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read(config_file)
        self._ftpServer = FtpControl()

    def tearDown(self):
        print "DONE"    
        
    def check_get_pbsz(self):
        print "in check_get_pbsz"
        size = self._ftpServer.get_pbsz()
        print size
        
def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(FtpControlTestCaseOne, "check"))
    suite.addTest(unittest.makeSuite(FtpControlTestCaseTwo, "check"))
    return suite


def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
