############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################
from pyGlobus import gassCopy
from pyGlobus import ftpClient
from pyGlobus.util import GlobusException
import ConfigParser, unittest

#The config file is ../../test/config.py
config = None # ConfigParser object

SECTION = "gassCopy"
GSI_FTP_SRC = "gsiftpSrcUrl"
GSI_FTP_DEST = "gsiftpDestUrl"

#############################################################################
#  Unit test for the gassCopy Module.
##############################################################################
class GassCopyTestCase(unittest.TestCase):
    "Test case for the GassCopy module"

    def setUp(self):
        global config
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read("config.py")
        print "\nGassCopy Test unittest begin\n"
        return

    def tearDown(self):
        print "\nGassCopyTestCase finished\n"
        return
    
    def checkGassCopyGSIFTPURLToGSIFTPURLBlocking(self):
        try:
            handleAttr = gassCopy.HandleAttr()
            ftpHandleAttr = ftpClient.HandleAttr()
            handleAttr.set_ftp(ftpHandleAttr)
            gCopy = gassCopy.GassCopy(handleAttr)
            srcAttr = gassCopy.Attr()
            destAttr = gassCopy.Attr()
            srcFtpAttr = ftpClient.OperationAttr()
            destFtpAttr = ftpClient.OperationAttr()
            srcAttr.set_ftp(srcFtpAttr)
            destAttr.set_ftp(destFtpAttr)
            srcUrl = config.get(SECTION, GSI_FTP_SRC)
            destUrl = config.get(SECTION, GSI_FTP_DEST)
            gCopy.copy_url_to_url(srcUrl, srcAttr, destUrl, destAttr)
        except GlobusException, ex:
            print "Exception occured during testing."
            assert 0, ex.args

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(GassCopyTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    



