############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################
from pyGlobus.gassFile import GassFile
from pyGlobus.util import GlobusException
import ConfigParser, unittest

#The config file is ../../test/config.py
config = None # ConfigParser object

SECTION = "gassFile"
SRC = "readFile"
DEST = "writeFile"

#############################################################################
#  Unit test for the gassFile Module.
##############################################################################
class GassFileTestCase(unittest.TestCase):
    "Test case for the GassFile module"

    def setUp(self):
        global config
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read("config.py")
        print "\nGassFile Test unittest begin\n"
        return

    def tearDown(self):
        print "\nGassFileTestCase finished\n"
        return
    
    def checkGassFilePythonFileLocal(self):
        try:
            src = config.get(SECTION, SRC)
            dest = config.get(SECTION, DEST)
            gSrcFile = GassFile()
            gDestFile = GassFile()
            fSrc = gSrcFile.fopen(src, "r")
            fDest = gDestFile.fopen(dest, "w+")
            lines = fSrc.readlines()
            fDest.writelines(lines)
            gSrcFile.fclose(fSrc)
            gDestFile.fclose(fDest)
            del gSrcFile
            del gDestFile
        except GlobusException, ex:
            print "Exception occured during testing."
            assert 0, ex.args

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(GassFileTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    
