from pyGlobus.gramClient import GramClient, JOB_STATE_PENDING, JOB_STATE_ACTIVE
from pyGlobus.gramClient import JOB_STATE_FAILED, JOB_STATE_DONE, JOB_STATE_ALL
from pyGlobus.util import GlobusException
import sys, ConfigParser, unittest
from threading import *

cond = 0
config = None # ConfigParser object

def func(cv, contact, state, error):
    global cond
    if state == JOB_STATE_PENDING:
        print "Job is pending"
    elif state == JOB_STATE_ACTIVE:
        print "Job is active"
    elif state == JOB_STATE_FAILED:
        print "Job failed"
        cv.acquire()
        cond = 1
        cv.notify()
        cv.release()
    elif state == JOB_STATE_DONE:
        print "Job is done"
        cv.acquire()
        cond = 1
        cv.notify()
        cv.release()


#############################################################################
#  Unit test for the GramClient Module:
#  Given a remote machine and an rsl command, the test function creates a
#  GramClient object and which sends the rsl message to the remote machine
#  and if all goes well then the command is executed.
#
##############################################################################


class GramClientTestCase(unittest.TestCase):
    "Test case for the GramClient module"
    
    def checkGramClient(self):
        global config, cond
        print  "\nGramClientTestCase begin.\n"
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read("config.py")
            
        rm = config.get("gramClient", "rm")
        rsl = config.get("gramClient", "rsl")
        condV = Condition(Lock())
        try:
            gramClient = GramClient()
            assert not gramClient == None, "Error creating the GramClient object"
            callbackContact = gramClient.set_callback(func, condV)
            jobContact = gramClient.submit_request(rm, rsl, JOB_STATE_ALL,
            callbackContact)
            while cond == 0: 
                condV.acquire()
                condV.wait()
                condV.release()
            gramClient.remove_callback(callbackContact)
            print "\nGramClientTestCase finished\n"
        except GlobusException, ex:
            assert 0, ex.args
def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(GramClientTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    
                  

