import ConfigParser, unittest
from pyGlobus.test import test_GSSContext
from pyGlobus.test import test_GSSName
from pyGlobus.test import test_GSSCred

"""
Unittest for the security package.
"""

config = None # ConfigParser object

def makeTestSuite():
    global config
    if config == None:
        config = ConfigParser.ConfigParser()
        config.read("config.py")
    test_GSSContext.config = config
    test_GSSName.config = config
    suite = unittest.TestSuite()
    suite.addTest(test_GSSContext.makeTestSuite())
    suite.addTest(test_GSSName.makeTestSuite())
    suite.addTest(test_GSSCred.makeTestSuite())
    return suite

def main():
    global config
    if config == None:
        config = ConfigParser.ConfigParser()
        config.read("config.py")
    test_GSSContext.config = config
    test_GSSName.config = config
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    
                  

