/*############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################*/

%typemap(python, in) PyObject *pyfunc {
    if (!PyCallable_Check($input)) {
        PyErr_SetString(PyExc_TypeError, "expected PyCallable");
        return NULL;
    }
    $1=$input;
}

%typemap(python, argout) globus_bool_t* boolRet{
    PyObject* o;
    o = PyInt_FromLong((int)*$1);
    if ((!$result) || ($result == Py_None)) {
        $result = o;
    } else {
        if (!PyList_Check($result)) {
            PyObject *o2 = $result;
            $result = PyList_New(0);
            PyList_Append($result, o2);
            Py_XDECREF(o2);
        }
        PyList_Append($result, o);
        Py_XDECREF(o);
    }
}

%typemap(python,argout) char **OUTPUT {
    PyObject *o;
    if (*$1 != NULL) {
        o = PyString_FromString(*$1);
    }
    else {
        o = PyString_FromString("");
    }
    if ((!$result) || ($result == Py_None)) {
        $result = o;
    } else {
        if (!PyList_Check($result)) {
            PyObject *o2 = $result;
            $result = PyList_New(0);
            PyList_Append($result, o2);
            Py_XDECREF(o2);
        }
        PyList_Append($result, o);
        Py_XDECREF(o);
    }
    globus_free(*$1);
}

%typemap(python,argout) int *intRet {
    PyObject *o;
    o = PyInt_FromLong(*$1);
    if ((!$result) || ($result == Py_None)) {
	$result = o;
    } else {
	if (!PyList_Check($result)) {
	    PyObject *o2 = $result;
	    $result = PyList_New(0);
	    PyList_Append($result,o2);
	    Py_XDECREF(o2);
	}
	PyList_Append($result,o);
	Py_XDECREF(o);
    }
}

%typemap(python,argout) unsigned short *ushortRet {
    PyObject *o;
    o = PyInt_FromLong(*$1);
    if ((!$result) || ($result == Py_None)) {
	$result = o;
    } else {
	if (!PyList_Check($result)) {
	    PyObject *o2 = $result;
	    $result = PyList_New(0);
	    PyList_Append($result,o2);
	    Py_XDECREF(o2);
	}
	PyList_Append($result,o);
	Py_XDECREF(o);
    }
}

%typemap(python,argout) unsigned int *uintRet {
    PyObject *o;
    o = PyInt_FromLong(*$1);
    if ((!$result) || ($result == Py_None)) {
	$result = o;
    } else {
	if (!PyList_Check($result)) {
	    PyObject *o2 = $result;
	    $result = PyList_New(0);
	    PyList_Append($result,o2);
	    Py_XDECREF(o2);
	}
	PyList_Append($result,o);
	Py_XDECREF(o);
    }
}

%typemap(python, argout) unsigned long *ulongRet {
    PyObject *o;
    if (sizeof(unsigned long) == 8) {
        o = PyLong_FromUnsignedLong(*$1);
    }
    else {
        o = PyInt_FromLong(*$1);
    }
    if ((!$result) || ($result == Py_None)) {
	$result = o;
    } else {
	if (!PyList_Check($result)) {
	    PyObject *o2 = $result;
	    $result = PyList_New(0);
	    PyList_Append($result,o2);
	    Py_XDECREF(o2);
	}
	PyList_Append($result,o);
	Py_XDECREF(o);
    }
}

%typemap(python, in) PyObject * {
    $1=$input;
}

%typemap(python, out) PyObject * {
    $result=$1;
}

%typemap(python, in, numinputs=1) globus_bool_t* boolRet(globus_bool_t temp) {
    $1 = &temp;
}

%typemap(python, in, numinputs=1) char **OUTPUT(char * temp) {
    temp = NULL;
    $1 = &temp;
}

%typemap(python, in, numinputs=1) int* intRet(int temp) {
    $1 = &temp;
}

%typemap(python, in, numinputs=1) unsigned short* ushortRet(unsigned short temp) {
    $1 = &temp;
}

%typemap(python, in, numinputs=1) unsigned int* uintRet(unsigned int temp) {
    $1 = &temp;
}

%typemap(python, in, numinputs=1) unsigned long *ulongRet(unsigned long temp) {
    $1 = &temp;
}

%include typemaps.i
