############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################
import unittest, ConfigParser
from pyGlobus.test import test_gramClient
from pyGlobus.test import test_gassServerEZ
from pyGlobus.test import test_util
from pyGlobus.test import test_security
from pyGlobus.test import test_ftpClient
from pyGlobus.test import test_gassCopy
from pyGlobus.test import test_gassFile
from pyGlobus.test import test_gassCache
from pyGlobus.test import test_gassTransfer
from pyGlobus.test import test_io
from pyGlobus.test import test_replicaCatalog
from pyGlobus.test import test_replicaManagement

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(test_util.makeTestSuite())
    suite.addTest(test_gramClient.makeTestSuite())
    suite.addTest(test_gassServerEZ.makeTestSuite())
    suite.addTest(test_security.makeTestSuite())
    suite.addTest(test_ftpClient.makeTestSuite())
    suite.addTest(test_gassCopy.makeTestSuite())
    suite.addTest(test_gassFile.makeTestSuite())
    suite.addTest(test_gassCache.makeTestSuite())
    suite.addTest(test_gassTransfer.makeTestSuite())
    suite.addTest(test_io.makeTestSuite())
    suite.addTest(test_replicaCatalog.makeTestSuite())
    suite.addTest(test_replicaManagement.makeTestSuite())
    return suite

def main():
    cp = ConfigParser.ConfigParser()
    cp.read("config.py")
    test_gramClient.config = cp
    test_gassServerEZ.config = cp
    test_security.config = cp
    test_ftpClient.config = cp
    test_gassCopy.config = cp
    test_gassFile.config = cp
    test_gassCache.config = cp
    test_gassTransfer.config = cp
    test_io.config = cp
    test_replicaCatalog.config = cp
    test_replicaManagement.config = cp
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    

